unit gest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Math, ExtCtrls, IniFiles, ComCtrls, Menus, ShellAPI, Spin;

const WM_NOTIFYTRAYICON = WM_USER + 1;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    Button2: TButton;
    List1: TListBox;
    Button3: TButton;
    List2: TListBox;
    OD: TOpenDialog;
    Timer1: TTimer;
    HK: THotKey;
    CB: TCheckBox;
    SE: TSpinEdit;
    PM: TPopupMenu;
    Exit1: TMenuItem;
    Restore1: TMenuItem;
    CB2: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure List2DblClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormResize(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure CBClick(Sender: TObject);
    procedure List1Click(Sender: TObject);
    procedure Image1DblClick(Sender: TObject);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SEChange(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Restore1Click(Sender: TObject);
    procedure CB2Click(Sender: TObject);
  private
    procedure HotKey(var Msg: TMessage); message WM_HOTKEY;
    procedure TrayIcon(var soobch: TMessage); message WM_NOTIFYTRAYICON;
    procedure Minz(Sender: TObject);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  pnt, pnt2: TPoint;
  s: Array [0..100] of boolean;
  gst: Array [0..100, 0..100] of integer;
  s2: Array [0..100] of Integer;
  a: Array[0..100] of String;
  s3: Array[0..100] of Integer;
  inif: TIniFile;
  t,e,p,b,b2,r2,u,xx,yy,xx2,yy2,x2,y2,tx,ty,max: Integer;
  dx, dy, d: single;
  q, fl, HKU, sh, mv, clc: boolean;
  o, CurDir, RDir: String;
  y: TRect;
  tray: TNotifyIconData;
  d2: single;
  modif: Integer;
  ss: TShiftState;
  K: Word;
  const w: integer=45; //
        ch: integer=30; //  
        f: Boolean=True;

implementation

{$R *.DFM}

procedure Drawing;
begin
if Form1.List1.ItemIndex>=0 then begin
        Form1.Image1.Canvas.Pen.Color:=clBlack;
        Form1.Image1.Canvas.FillRect(y);
        xx:=x2;
        yy:=y2;
        Form1.Image1.Canvas.Brush.Style:=bsSolid;
        Form1.Image1.Canvas.Brush.Color:=clBlue;
        Form1.Image1.Canvas.Ellipse(xx-3, yy-3, xx+3, yy+3);
        Form1.Image1.Canvas.Brush.Color:=clWhite;
        Form1.Image1.Canvas.MoveTo(xx, yy);
        For t:=0 to s2[Form1.List1.ItemIndex]-1 do begin
                xx:=xx+Round(cos(gst[Form1.List1.ItemIndex, t]/180*pi)*StrToInt(Form1.SE.Text));
                yy:=yy-Round(sin(gst[Form1.List1.ItemIndex, t]/180*pi)*StrToInt(Form1.SE.Text));
                With Form1.Image1.Canvas do begin
                        LineTo(xx, yy);
                        Pen.Color:=clRed;
                        LineTo(xx+Round(cos((gst[Form1.List1.ItemIndex, t]+160)/180*pi)*5), yy-Round(sin((gst[Form1.List1.ItemIndex, t]+160)/180*pi)*5));
                        MoveTo(xx, yy);
                        LineTo(xx+Round(cos((gst[Form1.List1.ItemIndex, t]-160)/180*pi)*5), yy-Round(sin((gst[Form1.List1.ItemIndex, t]-160)/180*pi)*5));
                        MoveTo(xx, yy);
                        Pen.Color:=clBlack;
                end;
        end;
end;
end;

procedure advrec;
begin
while not f do begin
        GetCursorPos(pnt);
        dx:=pnt.x-Form1.Left-Form1.Width+Form1.ClientWidth+5-xx;
        dy:=yy-(pnt.y-Form1.Top-Form1.Height+Form1.ClientHeight+5);
        d:=(arctan(dy/(dx+0.1))*180/Pi);
        d:=ch*(Round(d/ch));
        if dx<0 then d:=d+180 else if dy<0 then d:=d+360;
        if d=360 then d:=0;
        if (b>0) and (gst[p,b-1]=d) then clc:=False;
        if clc then begin
                clc:=False;
                xx:=tx;
                yy:=ty;
                Form1.Image1.Canvas.MoveTo(xx, yy);
                tx:=xx+Round(cos(gst[P, B]/180*pi)*StrToInt(Form1.SE.Text));
                ty:=yy-Round(sin(gst[P, B]/180*pi)*StrToInt(Form1.SE.Text));
                Form1.Image1.Canvas.LineTo(tx, ty);
                Form1.Image1.Canvas.Pen.Color:=clRed;
                Form1.Image1.Canvas.LineTo(tx+Round(cos((gst[P, B]+160)/180*pi)*5), ty-Round(sin((gst[P, B]+160)/180*pi)*5));
                Form1.Image1.Canvas.MoveTo(tx, ty);
                Form1.Image1.Canvas.LineTo(tx+Round(cos((gst[P, B]-160)/180*pi)*5), ty-Round(sin((gst[P, B]-160)/180*pi)*5));
                Form1.Image1.Canvas.MoveTo(xx, yy);
                Form1.Image1.Canvas.Pen.Color:=clBlack;
                inc(b);
                s2[p]:=b;
        end;
        if (d<>d2) then begin
                Drawing;
                gst[p, b]:=Round(d);
                d2:=d;
                Form1.Image1.Canvas.MoveTo(xx, yy);
                tx:=xx+Round(cos(gst[P, B]/180*pi)*StrToInt(Form1.SE.Text));
                ty:=yy-Round(sin(gst[P, B]/180*pi)*StrToInt(Form1.SE.Text));
                Form1.Image1.Canvas.LineTo(tx, ty);
                Form1.Image1.Canvas.Pen.Color:=clRed;
                Form1.Image1.Canvas.LineTo(tx+Round(cos((gst[P, B]+160)/180*pi)*5), ty-Round(sin((gst[P, B]+160)/180*pi)*5));
                Form1.Image1.Canvas.MoveTo(tx, ty);
                Form1.Image1.Canvas.LineTo(tx+Round(cos((gst[P, B]-160)/180*pi)*5), ty-Round(sin((gst[P, B]-160)/180*pi)*5));
                Form1.Image1.Canvas.MoveTo(xx, yy);
                Form1.Image1.Canvas.Pen.Color:=clBlack;
        end;
        Application.ProcessMessages;
        Sleep(1);
end;
Form1.Button2.Caption:='Record';
Form1.Button3.Enabled:=True;
end;

procedure TForm1.Minz(Sender: TObject);
begin
ShowWindow(Application.Handle, SW_HIDE);
end;

procedure TForm1.TrayIcon(var soobch: TMessage);
var p: TPoint;
begin
if soobch.LParam=WM_LBUTTONDOWN then begin
        Application.Restore;
        ShowWindow(Application.Handle, SW_SHOW);
        SetForegroundWindow(Form1.Handle);
end;
if soobch.LParam=WM_RBUTTONDOWN then begin
        SetForegroundWindow(Form1.Handle);
        GetCursorPos(p);
        PM.Popup(p.x, p.y);
end;
end;

procedure TForm1.HotKey(var Msg: TMessage);
begin
Button1.Click;
end;

procedure Loading;
begin
inif:=TIniFile.Create('.\Gesture.ini');
for T:=0 to p-1 do begin
        o:=Inif.ReadString('Main', IntToStr(T+1), '');
        e:=1;
        b:=0;
        while e<=Length(o) do begin
                if o[e]=' ' then begin
                        gst[t, b]:=StrToInt(copy(o, 1, e-1));
                        o:=Copy(o, e+1, Length(o)-e);
                        Inc(b);
                        e:=0;
                end;
        Inc(e);
        end;
        gst[t, b]:=StrToInt(o);
        Inc(b);
        s2[t]:=b;
        Form1.List1.Items.Add(IntToStr(t));
        Form1.List2.Items.Add(Inif.ReadString('Main', 'a'+IntToStr(t), ''));
        a[t]:=Inif.ReadString('Main', 'a'+IntToStr(t), '')
end;
Inif.Free;
end;

function gestr(r: integer; n: integer): boolean;
begin
dx:=pnt.x-pnt2.x;
dy:=pnt2.y-pnt.y;
d:=Round(arctan(dy/(dx+0.00001))*180/Pi);
if dx<0 then d:=d+180 else if dy<0 then d:=d+360;
if (abs(gst[r,n]-d)<w) or (abs(gst[r,n]-d+360)<w) then begin
        Result:=True;
        exit;
end;
Result:=False;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
UnRegisterHotKey(Form1.handle, $8760);
modif:=0;
if (hkCtrl in HK.Modifiers) then modif:=modif+MOD_CONTROL;
if (hkAlt in HK.Modifiers) then modif:=modif+MOD_ALT;
if (hkShift in HK.Modifiers) then modif:=modif+MOD_SHIFT;
ShortCutToKey(HK.HotKey, K, SS);
if k=0 then UnRegisterHotKey(Form1.handle, $8760) else if not RegisterHotKey(Form1.Handle, $8760, Modif, k) then begin
        Application.MessageBox('  !', '!', MB_OK+MB_ICONERROR);
        HK.enabled:=true;
        UnRegisterHotKey(Form1.Handle, $8760);
        HK.SetFocus;
        exit;
end;
f:=not f;
GetCursorPos(pnt2);
if not f then Button1.Caption:='Go-go-go!' else Button1.Caption:='Start';
u:=0;
for t:=0 to p-1 do s3[t]:=0;
while not f do begin
        GetCursorPos(pnt);
        dx:=pnt2.x-pnt.x;
        dy:=pnt2.y-pnt.y;
        if Sqrt(dx*dx+dy*dy)>20 then begin
                max:=0;
                for e:=0 to p-1 do begin
                        if s3[e]>0 then if gestr(e, s3[e]) then begin
                                Inc(s3[e]);
                        end else if not gestr(e, s3[e]-1) then begin
                                s3[e]:=0;
                                Inc(u);
                        end;
                        if s3[e]=0 then if gestr(e, s3[e]) then begin
                                Inc(s3[e]);
                                Timer1.Enabled:=True;
                        end;
                end;
                Pnt2:=Pnt;
        end;
        if u>=p-1 then begin
                u:=0;
                Timer1.Enabled:=False;
        end;
        for e:=0 to p-1 do begin
                if a[e]<>'' then if (s3[e]=s2[e]) then begin
                        for t:=0 to p-1 do s3[t]:=0;
                        List1.ItemIndex:=e;
                        List2.ItemIndex:=e;
                        u:=0;
                        r2:=0;
                        Timer1.Enabled:=False;
                        RDir:=a[e];
                        while RDir[length(RDir)]<>'\' do RDir:=Copy(RDir, 1, length(RDir)-1);
                        ShellExecute(Form1.Handle, nil, PChar(a[e]), nil, PChar(RDir), SW_SHOW);
                        Drawing;
                        if HKU then Button1.Click;
                end;
        end;
        Application.ProcessMessages;
        Sleep(1);
end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
clc:=false;
Application.OnMinimize:=Minz;
Inif:=TIniFile.Create('.\gesture.ini');
x2:=Inif.ReadInteger('Main', 'x2', 0);
y2:=Inif.ReadInteger('Main', 'y2', 0);
SE.Text:=Inif.ReadString('Main', 'Scale', '15');
HK.HotKey:=TextToShortCut(Inif.ReadString('Main', 'Hotkey', ''));
if Inif.ReadString('Main', 'HK', 'no')='yes' then begin
        Inif.Free;
        CB.Checked:=True;
end;
Inif:=TIniFile.Create('.\gesture.ini');
if Inif.ReadString('Main', 'AR', 'no')='yes' then begin
        Inif.Free;
        CB2.Checked:=True;
end;
UnRegisterHotKey(Form1.handle, $8760);
with tray do begin
        cbSize := SizeOf(tray);
        Wnd := Form1.Handle;
        uID := 1;
        uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
        uCallBackMessage := WM_NOTIFYTRAYICON;
        hIcon := Form1.Icon.Handle;
        szTip := 'Sign&Run';
end;
Shell_NotifyIcon(NIM_ADD, Addr(tray));
modif:=0;
if (hkCtrl in HK.Modifiers) then modif:=modif+MOD_CONTROL;
if (hkAlt in HK.Modifiers) then modif:=modif+MOD_ALT;
if (hkShift in HK.Modifiers) then modif:=modif+MOD_SHIFT;
ShortCutToKey(HK.HotKey, K, SS);
if k=0 then UnRegisterHotKey(Form1.handle, $8760) else if not RegisterHotKey(Form1.Handle, $8760, Modif, k) then begin
        Application.MessageBox('  !', '!', MB_OK+MB_ICONERROR);
        HK.enabled:=true;
        UnRegisterHotKey(Form1.Handle, $8760);
        HK.SetFocus;
        exit;
end;
Inif:=TIniFile.Create('.\gesture.ini');
y:=Bounds(0, 0, Image1.Width, Image1.Height);
CurDir:=Application.ExeName;
while CurDir[length(CurDir)]<>'\' do CurDir:=Copy(CurDir, 1, length(CurDir)-1);
p:=inif.ReadInteger('Main', 'Num', 0);
for T:=0 to p-1 do begin
        o:=Inif.ReadString('Main', IntToStr(T+1), '');
        e:=1;
        b:=0;
        while e<=Length(o) do begin
                if o[e]=' ' then begin
                        gst[t, b]:=StrToInt(copy(o, 1, e-1));
                        o:=Copy(o, e+1, Length(o)-e);
                        Inc(b);
                        e:=0;
                end;
        Inc(e);
        end;
        gst[t, b]:=StrToInt(o);
        Inc(b);
        s2[t]:=b;
        List1.Items.Add(IntToStr(t));
        List2.Items.Add(Inif.ReadString('Main', 'a'+IntToStr(t), ''));
        a[t]:=Inif.ReadString('Main', 'a'+IntToStr(t), '')
end;
Inif.Free;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
if (key=#8) and (F=False) then begin
        if b>0 then Dec(b) else begin
                f:=true;
                Image1.Canvas.FillRect(y);
                List1.Items.Delete(p);
                List2.Items.Delete(p);
                exit;
        end;
        s2[p]:=b;
        Drawing;
        d2:=gst[p,b-1];
        pnt2:=pnt;
end;
if (key=#27) and (sh=True) then sh:=False;
if (key=#27) and (F=False) then begin
        f:=true;
        o:='';
        s2[p]:=b;  
        Drawing;
        for t:=0 to b-1 do o:=o+IntToStr(gst[p,t])+' ';
        Inif:=TIniFile.Create('.\Gesture.ini');
        Inc(p);
        Inif.WriteInteger('Main', 'Num', p);
        Inif.WriteString('Main', IntToStr(p), o);
        Inif.Free;
end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
if Button2.Caption<>'Record' then exit;
Button2.Caption:='Recording...';
Button3.Enabled:=False;
b:=0;
f:=False;
Image1.Canvas.FillRect(y);
Image1.Canvas.Pen.Color:=clBlack;
xx:=x2;
yy:=y2;
Image1.Canvas.Brush.Style:=bsSolid;
Image1.Canvas.Brush.Color:=clBlue;
Image1.Canvas.Ellipse(xx-3, yy-3, xx+3, yy+3);
Image1.Canvas.Brush.Color:=clWhite;
d2:=999;
Form1.List1.Items.Add(IntToStr(p));
Form1.List2.Items.Add('');
Form1.List1.ItemIndex:=p;
if CB2.Checked then begin
        f:=false;
        advrec;
        exit;
end;
SetCursorPos(Screen.Width div 2, Screen.Height div 2);
GetCursorPos(pnt2);
while not f do begin
        GetCursorPos(pnt);
        dx:=pnt.x-pnt2.x;
        dy:=pnt2.y-pnt.y;
        d:=(arctan(dy/(dx+0.1))*180/Pi);
        d:=ch*(Round(d/ch));
        if dx<0 then d:=d+180 else if dy<0 then d:=d+360;
        if d=360 then d:=0;
        if (d<>d2) and (Sqrt(dx*dx+dy*dy)>20) then begin
                gst[p, b]:=Round(d);
                d2:=d;
                pnt2:=pnt;
                Image1.Canvas.MoveTo(xx, yy);
                xx:=xx+Round(cos(gst[P, B]/180*pi)*StrToInt(SE.Text));
                yy:=yy-Round(sin(gst[P, B]/180*pi)*StrToInt(SE.Text));
                Image1.Canvas.LineTo(xx, yy);
                Image1.Canvas.Pen.Color:=clRed;
                Image1.Canvas.LineTo(xx+Round(cos((gst[P, B]+160)/180*pi)*5), yy-Round(sin((gst[P, B]+160)/180*pi)*5));
                Image1.Canvas.MoveTo(xx, yy);
                Image1.Canvas.LineTo(xx+Round(cos((gst[P, B]-160)/180*pi)*5), yy-Round(sin((gst[P, B]-160)/180*pi)*5));
                Image1.Canvas.MoveTo(xx, yy);
                Image1.Canvas.Pen.Color:=clBlack;
                Inc(b);
                s2[p]:=b;
        end;
        Application.ProcessMessages;
        Sleep(1);
end;
Button2.Caption:='Record';
Button3.Enabled:=True;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
If List1.ItemIndex>=0 then begin
        Inif:=TIniFile.Create('.\Gesture.ini');
        Inif.DeleteKey('Main', IntToStr(List1.ItemIndex+1));
        Inif.DeleteKey('Main', 'A'+IntToStr(List1.ItemIndex));
        for t:=List1.ItemIndex+1 to p-1 do begin
                a[t-1]:=a[t];
                gst[t-1]:=gst[t];
                s2[t-1]:=s2[t];
                Inif.WriteString('Main', IntToStr(t), Inif.ReadString('Main', IntToStr(t+1), ''));
                Inif.WriteString('Main', 'a'+IntToStr(t-1), Inif.ReadString('Main', 'a'+IntToStr(t), ''));
                List1.Items[t]:=IntToStr(t-1);
        end;
        Inif.DeleteKey('Main', IntToStr(p));
        Inif.DeleteKey('Main', 'a'+IntToStr(p));
        a[p-1]:='';
        gst[p-1]:=gst[p];
        s2[p-1]:=0;
        Dec(p);
        Inif.WriteInteger('Main', 'Num', P);
        List2.Items.Delete(List1.ItemIndex);
        List1.Items.Delete(List1.ItemIndex);
        Inif.Free;
        Image1.Canvas.FillRect(y);
end;
end;

procedure TForm1.List2DblClick(Sender: TObject);
begin
OD.InitialDir:='.';
if OD.Execute then begin
        List2.Items[List2.ItemIndex]:=OD.FileName;
        a[List2.ItemIndex]:=OD.FileName;
        SetCurrentDirectory(PChar(CurDir));
        Inif:=TIniFile.Create('.\Gesture.ini');
        Inif.WriteString('Main', 'A'+IntToStr(List2.ItemIndex), OD.FileName);
        Inif.Free;
end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
Timer1.Enabled:=False;
for t:=0 to p-1 do s3[t]:=0;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
f:=True;
sh:=False;
mv:=False;
UnregisterHotKey(Form1.Handle, $8760);
Inif:=TIniFile.Create('.\gesture.ini');
Inif.WriteString('Main', 'Hotkey', ShortCutToText(HK.HotKey));
Inif.WriteInteger('Main', 'Scale', StrToInt(SE.Text));
Inif.Free;
Shell_NotifyIcon(NIM_DELETE, Addr(tray));
end;

procedure TForm1.FormResize(Sender: TObject);
var w,h: Integer;
begin
W:=Form1.ClientWidth;
H:=Form1.ClientHeight;
Image1.Width:=W-377;
Image1.Height:=H-64;
HK.Top:=H-25;
Button1.Top:=H-57;
Button2.Top:=H-57;
List2.Left:=W-346;
List1.Left:=W-378;
List1.Height:=H-64;
List2.Height:=H-64;
Button3.Left:=W-346;
Button3.Top:=H-57;
CB.Top:=H-25;
CB2.Top:=H-25;
SE.Top:=H-56;
if fl then begin
        y:=Bounds(0, 0, Image1.Width, Image1.Height);
        Image1.Picture.Bitmap.Width:=Image1.Width;
        Image1.Picture.Bitmap.Height:=Image1.Height;
end;
Drawing;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
fl:=True;
Application.Minimize;
end;

procedure TForm1.CBClick(Sender: TObject);
begin
Inif:=TIniFile.Create('.\Gesture.ini');
if CB.Checked=True then begin
        Inif.WriteString('Main', 'HK', 'yes');
        HKU:=True;
end else begin
        Inif.WriteString('Main', 'HK', 'no');
        HKU:=False;
end;
Inif.Free;
end;

procedure TForm1.List1Click(Sender: TObject);
begin
Drawing;
end;

procedure TForm1.Image1DblClick(Sender: TObject);
begin
GetCursorPos(pnt);
xx2:=Pnt.X;
yy2:=Pnt.Y;
sh:=True;
List1.Enabled:=False;
For t:=0 to s2[Form1.List1.ItemIndex]-1 do begin
        for b2:=0 to 5 do begin
                if sh=False then begin
                        List1.Enabled:=True;
                        SetCursorPos(Pnt.X, Pnt.Y);
                        exit;
                end;
                SetCursorPos(xx2, yy2);
                xx2:=xx2+Round(cos(gst[Form1.List1.ItemIndex, t]/180*pi)*StrToInt(SE.Text)/5);
                yy2:=yy2-Round(sin(gst[Form1.List1.ItemIndex, t]/180*pi)*StrToInt(SE.Text)/5);
                For e:=0 to 300000 do Application.ProcessMessages;
                Sleep(1);
        end;
end;
List1.Enabled:=True;
SetCursorPos(Pnt.X, Pnt.Y);
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if Button=mbLeft then clc:=true;
if not (Button=mbRight) then exit;
mv:=not mv;
if not mv then begin
        Inif:=TIniFile.Create('.\gesture.ini');
        Inif.WriteInteger('Main', 'x2', x2);
        Inif.WriteInteger('Main', 'y2', y2);
        Inif.Free;
end;
while mv do begin
        GetCursorPos(Pnt);
        x2:=Pnt.X-Form1.Left-Form1.Width+Form1.ClientWidth+5;
        y2:=Pnt.Y-Form1.Top-Form1.Height+Form1.ClientHeight+5;
        Application.ProcessMessages;
        Sleep(1);
        Drawing;
end;
end;

procedure TForm1.SEChange(Sender: TObject);
begin
if SE.Text='' then SE.Text:='0';
SE.Text:=IntToStr(StrToInt(SE.Text));
Drawing;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
Shell_NotifyIcon(NIM_DELETE, Addr(tray));
Application.Terminate;
end;

procedure TForm1.Restore1Click(Sender: TObject);
begin
Application.Restore;
ShowWindow(Application.Handle, SW_SHOW);
SetForegroundWindow(Form1.Handle);
end;

procedure TForm1.CB2Click(Sender: TObject);
begin
Inif:=TIniFile.Create('.\Gesture.ini');
if CB2.Checked=True then Inif.WriteString('Main', 'AR', 'yes') else Inif.WriteString('Main', 'AR', 'no');
Inif.Free;
end;

end.
